Index: /branches/UKMO/dev_r5518_medusa_chg_trc_bio_medusa/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90
===================================================================
--- /branches/UKMO/dev_r5518_medusa_chg_trc_bio_medusa/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90	(revision 7885)
+++ /branches/UKMO/dev_r5518_medusa_chg_trc_bio_medusa/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90	(revision 7886)
@@ -2748,5 +2723,5 @@
                   !! apply the calculated scavenging rate ...
                   !!
-                  ffescav = fscal_scav * zfer
+                  ffescav(ji,jj) = fscal_scav * zfer(ji,jj)
                   !!
                elseif (jiron.eq.3) then
@@ -2762,5 +2737,5 @@
                   !!
                   !! total iron concentration (mmol Fe / m3 -> umol Fe / m3)
-                  xFeT        = zfer * 1.e3
+                  xFeT        = zfer(ji,jj) * 1.e3
                   !!
                   !! this has a base scavenging rate which is modified by local
@@ -2822,5 +2797,5 @@
                   !! apply the calculated scavenging rate ...
                   !!
-                  ffescav = fscal_scav * zfer
+                  ffescav(ji,jj) = fscal_scav * zfer(ji,jj)
                   !!
                elseif (jiron.eq.4) then
@@ -2861,5 +2836,5 @@
                   !!
                   !! sum these two terms together
-                  ffescav     = xORGscav + xINORGscav
+                  ffescav(ji,jj)     = xORGscav + xINORGscav
                else
                   !!----------------------------------------------------------------------
@@ -2869,5 +2844,5 @@
                   !! you fool!
                   !!----------------------------------------------------------------------
-                  ffescav     = 0.
+                  ffescav(ji,jj)     = 0.
                endif
 
@@ -2879,8 +2854,8 @@
                if (jk.eq.1) then
                   !! zirondep   is in mmol-Fe / m2 / day
-                  !! ffetop     is in mmol-dissolved-Fe / m3 / day
-                  ffetop  = zirondep(ji,jj) * xfe_sol / fthk 
+                  !! ffetop(ji,jj)     is in mmol-dissolved-Fe / m3 / day
+                  ffetop(ji,jj)  = zirondep(ji,jj) * xfe_sol / fse3t(ji,jj,jk) 
                else
-                  ffetop  = 0.0
+                  ffetop(ji,jj)  = 0.0
                endif
                !!
@@ -2888,12 +2863,12 @@
                !! AXY (10/07/12): amended to only apply sedimentary flux up to ~500 m down
                !! if (jk.eq.(mbathy(ji,jj)-1).AND.jk.lt.i1100) then
-               if ((jk.eq.jmbathy).AND.jk.le.i0500) then
+               if ((jk.eq.mbathy(ji,jj)).AND.jk.le.i0500) then
                   !! Moore et al. (2004) cite a coastal California value of 5 umol/m2/d, but adopt a
                   !! global value of 2 umol/m2/d for all areas < 1100 m; here we use this latter value
                   !! but apply it everywhere
                   !! AXY (21/07/09): actually, let's just apply it below 1100 m (levels 1-37)
-                  ffebot  = (xfe_sed / fthk)
+                  ffebot(ji,jj)  = (xfe_sed / fse3t(ji,jj,jk))
                else
-                  ffebot  = 0.0
+                  ffebot(ji,jj)  = 0.0
                endif
 
@@ -2903,7 +2878,7 @@
                !! iron addition at the seafloor is still permitted with the idea that this extra
                !! iron will be removed by the restoration away from the source
-               !! ffescav = 0.0
-               !! ffetop  = 0.0
-               !! ffebot  = 0.0
+               !! ffescav(ji,jj) = 0.0
+               !! ffetop(ji,jj)  = 0.0
+               !! ffebot(ji,jj)  = 0.0
 
 # if defined key_debug_medusa
@@ -2913,8 +2888,8 @@
                   IF (lwp) write (numout,*) 'xfe_sol  = ', xfe_sol
                   IF (lwp) write (numout,*) 'xfe_mass = ', xfe_mass
-                  IF (lwp) write (numout,*) 'ffetop(',jk,')  = ', ffetop
-                  IF (lwp) write (numout,*) 'ffebot(',jk,')  = ', ffebot
+                  IF (lwp) write (numout,*) 'ffetop(',jk,')  = ', ffetop(ji,jj)
+                  IF (lwp) write (numout,*) 'ffebot(',jk,')  = ', ffebot(ji,jj)
                   IF (lwp) write (numout,*) 'xFree(',jk,')   = ', xFree(ji,jj)
-                  IF (lwp) write (numout,*) 'ffescav(',jk,') = ', ffescav
+                  IF (lwp) write (numout,*) 'ffescav(',jk,') = ', ffescav(ji,jj)
                endif
 # endif
@@ -2925,5 +2900,5 @@
                !!
                !! diatom frustule dissolution
-               fsdiss  = xsdiss * zpds
+               fsdiss(ji,jj)  = xsdiss * zpds(ji,jj)
 
 # if defined key_debug_medusa
@@ -2931,5 +2906,5 @@
                if (idf.eq.1.AND.idfval.eq.1) then
                   IF (lwp) write (numout,*) '------------------------------'
-                  IF (lwp) write (numout,*) 'fsdiss(',jk,')  = ', fsdiss
+                  IF (lwp) write (numout,*) 'fsdiss(',jk,')  = ', fsdiss(ji,jj)
                endif
 # endif
@@ -2941,6 +2916,6 @@
                !! to allow the split between fast and slow detritus to be 
                !! diagnosed
-               fslown  = fdpn + fdzmi + ((1.0 - xfdfrac1) * fdpd) + &
-               ((1.0 - xfdfrac2) * fdzme) + ((1.0 - xbetan) * (finmi + finme))
+               fslown(ji,jj)  = fdpn(ji,jj) + fdzmi(ji,jj) + ((1.0 - xfdfrac1) * fdpd(ji,jj)) + &
+               ((1.0 - xfdfrac2) * fdzme(ji,jj)) + ((1.0 - xbetan) * (finmi(ji,jj) + finme(ji,jj)))
                !!
                !! this variable records the slow detrital sinking flux at this
@@ -2948,12 +2923,12 @@
                !! standard depths in the diagnostic outputs; needs to be
                !! adjusted from per second to per day because of parameter vsed
-               fslownflux(ji,jj) = zdet * vsed * 86400.
+               fslownflux(ji,jj) = zdet(ji,jj) * vsed * 86400.
 # if defined key_roam
                !!
                !! and the same for detrital carbon
-               fslowc  = (xthetapn * fdpn) + (xthetazmi * fdzmi) + &
-               (xthetapd * (1.0 - xfdfrac1) * fdpd) + &
-               (xthetazme * (1.0 - xfdfrac2) * fdzme) + &
-               ((1.0 - xbetac) * (ficmi + ficme))
+               fslowc(ji,jj)  = (xthetapn * fdpn(ji,jj)) + (xthetazmi * fdzmi(ji,jj)) + &
+               (xthetapd * (1.0 - xfdfrac1) * fdpd(ji,jj)) + &
+               (xthetazme * (1.0 - xfdfrac2) * fdzme(ji,jj)) + &
+               ((1.0 - xbetac) * (ficmi(ji,jj) + ficme(ji,jj)))
                !!
                !! this variable records the slow detrital sinking flux at this
@@ -2961,5 +2936,5 @@
                !! standard depths in the diagnostic outputs; needs to be
                !! adjusted from per second to per day because of parameter vsed
-               fslowcflux(ji,jj) = zdtc * vsed * 86400.
+               fslowcflux(ji,jj) = zdtc(ji,jj) * vsed * 86400.
 # endif
 
@@ -2975,22 +2950,23 @@
                !!
                !! nitrogen
-               fregen   = (( (xphi * (fgmipn + fgmid)) +                &  ! messy feeding
-               (xphi * (fgmepn + fgmepd + fgmezmi + fgmed)) +           &  ! messy feeding
-               fmiexcr + fmeexcr + fdd +                                &  ! excretion + D remin.
-               fdpn2 + fdpd2 + fdzmi2 + fdzme2) * fthk)                    ! linear mortality
+               fregen(ji,jj)   = (( (xphi * (fgmipn(ji,jj) + fgmid(ji,jj))) +                &  ! messy feeding
+               (xphi * (fgmepn(ji,jj) + fgmepd(ji,jj) + fgmezmi(ji,jj) + fgmed(ji,jj))) +           &  ! messy feeding
+               fmiexcr(ji,jj) + fmeexcr(ji,jj) + fdd(ji,jj) +                                &  ! excretion + D remin.
+               fdpn2(ji,jj) + fdpd2(ji,jj) + fdzmi2(ji,jj) + fdzme2(ji,jj)) * fse3t(ji,jj,jk))                    ! linear mortality
                !!
                !! silicon
-               fregensi = (( fsdiss + ((1.0 - xfdfrac1) * fdpds) +      &  ! dissolution + non-lin. mortality
-               ((1.0 - xfdfrac3) * fgmepds) +                           &  ! egestion by zooplankton
-               fdpds2) * fthk)                                             ! linear mortality
+               fregensi(ji,jj) = (( fsdiss(ji,jj) + ((1.0 - xfdfrac1) * fdpds(ji,jj)) +      &  ! dissolution + non-lin. mortality
+               ((1.0 - xfdfrac3) * fgmepds(ji,jj)) +                           &  ! egestion by zooplankton
+               fdpds2(ji,jj)) * fse3t(ji,jj,jk))                                             ! linear mortality
 # if defined key_roam
                !!
                !! carbon
-               fregenc  = (( (xphi * ((xthetapn * fgmipn) + fgmidc)) +  &  ! messy feeding
-               (xphi * ((xthetapn * fgmepn) + (xthetapd * fgmepd) +     &  ! messy feeding
-               (xthetazmi * fgmezmi) + fgmedc)) +                       &  ! messy feeding
-               fmiresp + fmeresp + fddc +                               &  ! respiration + D remin.
-               (xthetapn * fdpn2) + (xthetapd * fdpd2) +                &  ! linear mortality
-               (xthetazmi * fdzmi2) + (xthetazme * fdzme2)) * fthk)        ! linear mortality
+! Doesn't look this is used - marc 10/4/17
+!               fregenc(ji,jj)  = (( (xphi * ((xthetapn * fgmipn(ji,jj)) + fgmidc(ji,jj))) +  &  ! messy feeding
+!               (xphi * ((xthetapn * fgmepn(ji,jj)) + (xthetapd * fgmepd(ji,jj)) +     &  ! messy feeding
+!               (xthetazmi * fgmezmi(ji,jj)) + fgmedc(ji,jj))) +                       &  ! messy feeding
+!               fmiresp(ji,jj) + fmeresp(ji,jj) + fddc(ji,jj) +                               &  ! respiration + D remin.
+!               (xthetapn * fdpn2(ji,jj)) + (xthetapd * fdpd2(ji,jj)) +                &  ! linear mortality
+!               (xthetazmi * fdzmi2(ji,jj)) + (xthetazme * fdzme2(ji,jj))) * fse3t(ji,jj,jk))        ! linear mortality
 # endif
 
@@ -3005,23 +2981,21 @@
                !!
                !! nitrogen:   diatom and mesozooplankton mortality
-               ftempn         = b0 * ((xfdfrac1 * fdpd)  + (xfdfrac2 * fdzme))
+               ftempn(ji,jj)         = b0 * ((xfdfrac1 * fdpd(ji,jj))  + (xfdfrac2 * fdzme(ji,jj)))
                !!
                !! silicon:    diatom mortality and grazed diatoms
-               ftempsi        = b0 * ((xfdfrac1 * fdpds) + (xfdfrac3 * fgmepds))
+               ftempsi(ji,jj)        = b0 * ((xfdfrac1 * fdpds(ji,jj)) + (xfdfrac3 * fgmepds(ji,jj)))
                !!
                !! iron:       diatom and mesozooplankton mortality
-               ftempfe        = b0 * (((xfdfrac1 * fdpd) + (xfdfrac2 * fdzme)) * xrfn)
+               ftempfe(ji,jj)        = b0 * (((xfdfrac1 * fdpd(ji,jj)) + (xfdfrac2 * fdzme(ji,jj))) * xrfn)
                !!
                !! carbon:     diatom and mesozooplankton mortality
-               ftempc         = b0 * ((xfdfrac1 * xthetapd * fdpd) + & 
-                                (xfdfrac2 * xthetazme * fdzme))
+               ftempc(ji,jj)         = b0 * ((xfdfrac1 * xthetapd * fdpd(ji,jj)) + & 
+                                (xfdfrac2 * xthetazme * fdzme(ji,jj)))
                !!
 # if defined key_roam
                if (jrratio.eq.0) then
                   !! CaCO3:      latitudinally-based fraction of total primary production
-                  !!               absolute latitude of current grid cell
-                  flat           = abs(gphit(ji,jj))
                   !!               0.10 at equator; 0.02 at pole
-                  fcaco3         = xcaco3a + ((xcaco3b - xcaco3a) * ((90.0 - flat) / 90.0))
+                  fcaco3(ji,jj)         = xcaco3a + ((xcaco3b - xcaco3a) * ((90.0 - abs(gphit(ji,jj))) / 90.0))
                elseif (jrratio.eq.1) then
                   !! CaCO3:      Ridgwell et al. (2007) submodel, version 1
@@ -3032,5 +3006,5 @@
                      fq1 = 0.
                   endif
-                  fcaco3 = xridg_r0 * fq1
+                  fcaco3(ji,jj) = xridg_r0 * fq1
                elseif (jrratio.eq.2) then
                   !! CaCO3:      Ridgwell et al. (2007) submodel, version 2
@@ -3041,12 +3015,10 @@
                      fq1 = 0.
                   endif
-                  fcaco3 = xridg_r0 * fq1
+                  fcaco3(ji,jj) = xridg_r0 * fq1
                endif
 # else
                !! CaCO3:      latitudinally-based fraction of total primary production
-               !!               absolute latitude of current grid cell
-               flat           = abs(gphit(ji,jj))
                !!               0.10 at equator; 0.02 at pole
-               fcaco3         = xcaco3a + ((xcaco3b - xcaco3a) * ((90.0 - flat) / 90.0))
+               fcaco3(ji,jj)         = xcaco3a + ((xcaco3b - xcaco3a) * ((90.0 - abs(gphit(ji,jj))) / 90.0))
 # endif
                !! AXY (09/03/09): convert CaCO3 production from function of 
@@ -3056,14 +3028,14 @@
                !! chlorophyll to an export flux for which they apply conversion 
                !! factors to estimate the various elemental fractions (Si, Ca)
-               ftempca        = ftempc * fcaco3
+               ftempca(ji,jj)        = ftempc(ji,jj) * fcaco3(ji,jj)
 
 # if defined key_debug_medusa
                !! integrate total fast detritus production
                if (idf.eq.1) then
-                  fifd_n(ji,jj)  = fifd_n(ji,jj)  + (ftempn  * fthk)
-                  fifd_si(ji,jj) = fifd_si(ji,jj) + (ftempsi * fthk)
-                  fifd_fe(ji,jj) = fifd_fe(ji,jj) + (ftempfe * fthk)
+                  fifd_n(ji,jj)  = fifd_n(ji,jj)  + (ftempn(ji,jj)  * fse3t(ji,jj,jk))
+                  fifd_si(ji,jj) = fifd_si(ji,jj) + (ftempsi(ji,jj) * fse3t(ji,jj,jk))
+                  fifd_fe(ji,jj) = fifd_fe(ji,jj) + (ftempfe(ji,jj) * fse3t(ji,jj,jk))
 #  if defined key_roam
-                  fifd_c(ji,jj)  = fifd_c(ji,jj)  + (ftempc  * fthk)
+                  fifd_c(ji,jj)  = fifd_c(ji,jj)  + (ftempc(ji,jj)  * fse3t(ji,jj,jk))
 #  endif
                endif
@@ -3072,13 +3044,13 @@
                if (idf.eq.1.AND.idfval.eq.1) then
                   IF (lwp) write (numout,*) '------------------------------'
-                  IF (lwp) write (numout,*) 'fdpd(',jk,')    = ', fdpd
-                  IF (lwp) write (numout,*) 'fdzme(',jk,')   = ', fdzme
-                  IF (lwp) write (numout,*) 'ftempn(',jk,')  = ', ftempn
-                  IF (lwp) write (numout,*) 'ftempsi(',jk,') = ', ftempsi
-                  IF (lwp) write (numout,*) 'ftempfe(',jk,') = ', ftempfe
-                  IF (lwp) write (numout,*) 'ftempc(',jk,')  = ', ftempc
-                  IF (lwp) write (numout,*) 'ftempca(',jk,') = ', ftempca
-                  IF (lwp) write (numout,*) 'flat(',jk,')    = ', flat
-                  IF (lwp) write (numout,*) 'fcaco3(',jk,')  = ', fcaco3
+                  IF (lwp) write (numout,*) 'fdpd(',jk,')    = ', fdpd(ji,jj)
+                  IF (lwp) write (numout,*) 'fdzme(',jk,')   = ', fdzme(ji,jj)
+                  IF (lwp) write (numout,*) 'ftempn(',jk,')  = ', ftempn(ji,jj)
+                  IF (lwp) write (numout,*) 'ftempsi(',jk,') = ', ftempsi(ji,jj)
+                  IF (lwp) write (numout,*) 'ftempfe(',jk,') = ', ftempfe(ji,jj)
+                  IF (lwp) write (numout,*) 'ftempc(',jk,')  = ', ftempc(ji,jj)
+                  IF (lwp) write (numout,*) 'ftempca(',jk,') = ', ftempca(ji,jj)
+                  IF (lwp) write (numout,*) 'flat(',jk,')    = ', abs(gphit(ji,jj))
+                  IF (lwp) write (numout,*) 'fcaco3(',jk,')  = ', fcaco3(ji,jj)
                endif
 # endif
@@ -3151,10 +3123,10 @@
                      !! this is the SURFACE OCEAN BOX (no remineralisation)
                      !!
-                     freminc  = 0.0
-                     freminn  = 0.0
-                     freminfe = 0.0
-                     freminsi = 0.0
-                     freminca = 0.0
-                  elseif (jk.le.jmbathy) then
+                     freminc(ji,jj)  = 0.0
+                     freminn(ji,jj)  = 0.0
+                     freminfe(ji,jj) = 0.0
+                     freminsi(ji,jj) = 0.0
+                     freminca(ji,jj) = 0.0
+                  elseif (jk.le.mbathy(ji,jj)) then
                      !! this is an OCEAN BOX (remineralise some material)
                      !!
@@ -3162,8 +3134,8 @@
                      if (jocalccd.eq.0) then
                         !! use default CCD field
-                        fccd_dep = ocal_ccd(ji,jj)
+                        fccd_dep(ji,jj) = ocal_ccd(ji,jj)
                      elseif (jocalccd.eq.1) then
                         !! use calculated CCD field
-                        fccd_dep = f2_ccd_cal(ji,jj)
+                        fccd_dep(ji,jj) = f2_ccd_cal(ji,jj)
                      endif
                      !!
@@ -3178,13 +3150,13 @@
                         !! it needs to be protected in case ALL C is protected
                         if (fq4.lt.fq1) then
-                           fprotf   = (fq4 / (fq1 + tiny(fq1)))      !! protected fraction of total organic C     (non-dim)
+                           fprotf(ji,jj)   = (fq4 / (fq1 + tiny(fq1)))      !! protected fraction of total organic C     (non-dim)
                         else
-                           fprotf   = 1.0                            !! all organic C is protected                (non-dim)
+                           fprotf(ji,jj)   = 1.0                            !! all organic C is protected                (non-dim)
                         endif
-                        fq5      = (1.0 - fprotf)                    !! unprotected fraction of total organic C   (non-dim)
+                        fq5      = (1.0 - fprotf(ji,jj))                    !! unprotected fraction of total organic C   (non-dim)
                         fq6      = (fq0 * fq5)                       !! how much organic C is unprotected         (mol)
-                        fq7      = (fq6 * exp(-(fthk / xfastc)))     !! how much unprotected C leaves this box    (mol)
-                        fq8      = (fq7 + (fq0 * fprotf))            !! how much total C leaves this box          (mol)
-                        freminc  = (fq0 - fq8) / fthk                !! C remineralisation in this box            (mol)
+                        fq7      = (fq6 * exp(-(fse3t(ji,jj,jk) / xfastc)))     !! how much unprotected C leaves this box    (mol)
+                        fq8      = (fq7 + (fq0 * fprotf(ji,jj)))            !! how much total C leaves this box          (mol)
+                        freminc(ji,jj)  = (fq0 - fq8) / fse3t(ji,jj,jk)                !! C remineralisation in this box            (mol)
                         ffastc(ji,jj) = fq8                          
 # if defined key_debug_medusa
@@ -3194,15 +3166,15 @@
                               IF (lwp) write (numout,*) 'totalC(',jk,')  = ', fq1
                               IF (lwp) write (numout,*) 'prtctC(',jk,')  = ', fq4
-                              IF (lwp) write (numout,*) 'fprotf(',jk,')  = ', fprotf
+                              IF (lwp) write (numout,*) 'fprotf(',jk,')  = ', fprotf(ji,jj)
                               IF (lwp) write (numout,*) '------------------------------'
                               IF (lwp) write (numout,*) 'IN   C(',jk,')  = ', fq0
-                              IF (lwp) write (numout,*) 'LOST C(',jk,')  = ', freminc * fthk
+                              IF (lwp) write (numout,*) 'LOST C(',jk,')  = ', freminc(ji,jj) * fse3t(ji,jj,jk)
                               IF (lwp) write (numout,*) 'OUT  C(',jk,')  = ', fq8
-                              IF (lwp) write (numout,*) 'NEW  C(',jk,')  = ', ftempc * fthk
+                              IF (lwp) write (numout,*) 'NEW  C(',jk,')  = ', ftempc(ji,jj) * fse3t(ji,jj,jk)
                            endif
 # endif
                         else
-                        fq1      = fq0 * exp(-(fthk / xfastc))       !! how much organic C leaves this box        (mol)
-                        freminc  = (fq0 - fq1) / fthk                !! C remineralisation in this box            (mol)
+                        fq1      = fq0 * exp(-(fse3t(ji,jj,jk) / xfastc))       !! how much organic C leaves this box        (mol)
+                        freminc(ji,jj)  = (fq0 - fq1) / fse3t(ji,jj,jk)                !! C remineralisation in this box            (mol)
                         ffastc(ji,jj)  = fq1
                      endif
@@ -3211,9 +3183,9 @@
                      fq0      = ffastn(ji,jj)                        !! how much organic N enters this box        (mol)
                      if (iball.eq.1) then
-                        fq5      = (1.0 - fprotf)                    !! unprotected fraction of total organic N   (non-dim)
+                        fq5      = (1.0 - fprotf(ji,jj))                    !! unprotected fraction of total organic N   (non-dim)
                         fq6      = (fq0 * fq5)                       !! how much organic N is unprotected         (mol)
-                        fq7      = (fq6 * exp(-(fthk / xfastc)))     !! how much unprotected N leaves this box    (mol)
-                        fq8      = (fq7 + (fq0 * fprotf))            !! how much total N leaves this box          (mol)
-                        freminn  = (fq0 - fq8) / fthk                !! N remineralisation in this box            (mol)
+                        fq7      = (fq6 * exp(-(fse3t(ji,jj,jk) / xfastc)))     !! how much unprotected N leaves this box    (mol)
+                        fq8      = (fq7 + (fq0 * fprotf(ji,jj)))            !! how much total N leaves this box          (mol)
+                        freminn(ji,jj)  = (fq0 - fq8) / fse3t(ji,jj,jk)                !! N remineralisation in this box            (mol)
                         ffastn(ji,jj)  = fq8
 # if defined key_debug_medusa
@@ -3223,18 +3195,18 @@
                            IF (lwp) write (numout,*) 'totalN(',jk,')  = ', fq1
                            IF (lwp) write (numout,*) 'prtctN(',jk,')  = ', fq4
-                           IF (lwp) write (numout,*) 'fprotf(',jk,')  = ', fprotf
+                           IF (lwp) write (numout,*) 'fprotf(',jk,')  = ', fprotf(ji,jj)
                            IF (lwp) write (numout,*) '------------------------------'
-                           if (freminn < 0.0) then
+                           if (freminn(ji,jj) < 0.0) then
                               IF (lwp) write (numout,*) '** FREMIN ERROR **'
                            endif
                            IF (lwp) write (numout,*) 'IN   N(',jk,')  = ', fq0
-                           IF (lwp) write (numout,*) 'LOST N(',jk,')  = ', freminn * fthk
+                           IF (lwp) write (numout,*) 'LOST N(',jk,')  = ', freminn(ji,jj) * fse3t(ji,jj,jk)
                            IF (lwp) write (numout,*) 'OUT  N(',jk,')  = ', fq8
-                           IF (lwp) write (numout,*) 'NEW  N(',jk,')  = ', ftempn * fthk
+                           IF (lwp) write (numout,*) 'NEW  N(',jk,')  = ', ftempn(ji,jj) * fse3t(ji,jj,jk)
                         endif
 # endif
                      else
-                        fq1      = fq0 * exp(-(fthk / xfastc))       !! how much organic N leaves this box        (mol)
-                        freminn  = (fq0 - fq1) / fthk                !! N remineralisation in this box            (mol)
+                        fq1      = fq0 * exp(-(fse3t(ji,jj,jk) / xfastc))       !! how much organic N leaves this box        (mol)
+                        freminn(ji,jj)  = (fq0 - fq1) / fse3t(ji,jj,jk)                !! N remineralisation in this box            (mol)
                         ffastn(ji,jj)  = fq1
                      endif
@@ -3243,13 +3215,13 @@
                      fq0      = ffastfe(ji,jj)                       !! how much organic Fe enters this box       (mol)
                      if (iball.eq.1) then
-                        fq5      = (1.0 - fprotf)                    !! unprotected fraction of total organic Fe  (non-dim)
+                        fq5      = (1.0 - fprotf(ji,jj))                    !! unprotected fraction of total organic Fe  (non-dim)
                         fq6      = (fq0 * fq5)                       !! how much organic Fe is unprotected        (mol)
-                        fq7      = (fq6 * exp(-(fthk / xfastc)))     !! how much unprotected Fe leaves this box   (mol)
-                        fq8      = (fq7 + (fq0 * fprotf))            !! how much total Fe leaves this box         (mol)            
-                        freminfe = (fq0 - fq8) / fthk                !! Fe remineralisation in this box           (mol)
+                        fq7      = (fq6 * exp(-(fse3t(ji,jj,jk) / xfastc)))     !! how much unprotected Fe leaves this box   (mol)
+                        fq8      = (fq7 + (fq0 * fprotf(ji,jj)))            !! how much total Fe leaves this box         (mol)            
+                        freminfe(ji,jj) = (fq0 - fq8) / fse3t(ji,jj,jk)                !! Fe remineralisation in this box           (mol)
                         ffastfe(ji,jj) = fq8
                      else
-                        fq1      = fq0 * exp(-(fthk / xfastc))       !! how much total Fe leaves this box         (mol)      
-                        freminfe = (fq0 - fq1) / fthk                !! Fe remineralisation in this box           (mol)
+                        fq1      = fq0 * exp(-(fse3t(ji,jj,jk) / xfastc))       !! how much total Fe leaves this box         (mol)      
+                        freminfe(ji,jj) = (fq0 - fq1) / fse3t(ji,jj,jk)                !! Fe remineralisation in this box           (mol)
                         ffastfe(ji,jj) = fq1
                      endif
@@ -3257,33 +3229,33 @@
                      !! === biogenic silicon ===
                      fq0      = ffastsi(ji,jj)                       !! how much  opal centers this box           (mol) 
-                     fq1      = fq0 * exp(-(fthk / xfastsi))         !! how much  opal leaves this box            (mol)
-                     freminsi = (fq0 - fq1) / fthk                   !! Si remineralisation in this box           (mol)
+                     fq1      = fq0 * exp(-(fse3t(ji,jj,jk) / xfastsi))         !! how much  opal leaves this box            (mol)
+                     freminsi(ji,jj) = (fq0 - fq1) / fse3t(ji,jj,jk)                   !! Si remineralisation in this box           (mol)
                      ffastsi(ji,jj) = fq1
                      !!
                      !! === biogenic calcium carbonate ===
                      fq0      = ffastca(ji,jj)                       !! how much CaCO3 enters this box            (mol)
-                     if (fdep.le.fccd_dep) then
+                     if (fsdepw(ji,jj,jk).le.fccd_dep(ji,jj)) then
                         !! whole grid cell above CCD
                         fq1      = fq0                               !! above lysocline, no Ca dissolves          (mol)
-                        freminca = 0.0                               !! above lysocline, no Ca dissolves          (mol)
+                        freminca(ji,jj) = 0.0                               !! above lysocline, no Ca dissolves          (mol)
                         fccd(ji,jj) = real(jk)                       !! which is the last level above the CCD?    (#)
-                     elseif (fdep.ge.fccd_dep) then
+                     elseif (fsdepw(ji,jj,jk).ge.fccd_dep(ji,jj)) then
                         !! whole grid cell below CCD
-                        fq1      = fq0 * exp(-(fthk / xfastca))      !! how much CaCO3 leaves this box            (mol)
-                        freminca = (fq0 - fq1) / fthk                !! Ca remineralisation in this box           (mol)
+                        fq1      = fq0 * exp(-(fse3t(ji,jj,jk) / xfastca))      !! how much CaCO3 leaves this box            (mol)
+                        freminca(ji,jj) = (fq0 - fq1) / fse3t(ji,jj,jk)                !! Ca remineralisation in this box           (mol)
                      else
                         !! partial grid cell below CCD
-                        fq2      = fdep1 - fccd_dep                  !! amount of grid cell below CCD             (m)
+                        fq2      = fdep1(ji,jj) - fccd_dep(ji,jj)                  !! amount of grid cell below CCD             (m)
                         fq1      = fq0 * exp(-(fq2 / xfastca))       !! how much CaCO3 leaves this box            (mol)
-                        freminca = (fq0 - fq1) / fthk                !! Ca remineralisation in this box           (mol)
+                        freminca(ji,jj) = (fq0 - fq1) / fse3t(ji,jj,jk)                !! Ca remineralisation in this box           (mol)
                      endif
                      ffastca(ji,jj) = fq1 
                   else
                      !! this is BELOW THE LAST OCEAN BOX (do nothing)
-                     freminc  = 0.0
-                     freminn  = 0.0
-                     freminfe = 0.0
-                     freminsi = 0.0
-                     freminca = 0.0              
+                     freminc(ji,jj)  = 0.0
+                     freminn(ji,jj)  = 0.0
+                     freminfe(ji,jj) = 0.0
+                     freminsi(ji,jj) = 0.0
+                     freminca(ji,jj) = 0.0              
                   endif
 
